#version 330 core

in vec3 vPosition; // vertex position (in model space)
in vec3 vNormal; // vertex normal (in model space)

out vec3 PositionWorldPass;
out vec3 NormalWorldPass;

// Values that stay constant for the whole mesh.
uniform mat4 gModel, gView, gProjection;

void main()
{
	mat4 MVP = gProjection * gView * gModel;

	// Output position of the vertex, in clip space : gMVP * position
	gl_Position =  MVP * vec4(vPosition,1);
	
	// Position of the vertex, in world space
	PositionWorldPass = (gModel * vec4(vPosition,1)).xyz;
	
	// Vertex normal vector in world space
	NormalWorldPass = (gModel * vec4(vNormal, 1)).xyz;
}

